/*
 * (C) Copyright 2001 by Thomas Driemeyer <thomas@bitrot.de> www.bitrot.de.
 *
 * This is free software; you can redistribute it and/or modify it under the
 * terms of the GNU Library General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version. This library is distributed in the hope that it will
 * be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library
 * General Public License for more details.
 */

static const char version[]	= "0.3";
static const char date[]	= "17 Nov 2004";
static const int  nhistory	= 10;
#ifdef DESKTOP
static const char config_dir[]	= "";			// in home dir
static const char config_file[]	= ".otpkeygen.conf";	// in config_dir[]
#else
static const char config_dir[]	= "Settings";		// in home dir
static const char config_file[]	= "otpkeygen.conf";	// in config_dir[]
#endif

typedef struct {
	bool	md4;			// use MD4 instead of MD5
	int	number;			// challenge number
	char	*seed;			// challenge seed
	char	*phrase;		// passphrase, *NOT* saved to disk
} History;

class Config {
  public:
	Config();			// create empty Config
	bool	read();			// read config from file
	bool	write();		// write config to file
	const History
	       *get_history(int);	// get/set hist entry n=0...nhistory-1
	void	set_history(int, bool, int, const char *, const char *);
	void	insert_history(bool, int, const char *, const char *);
	int	get_lasthistory();	// last used history entry

  private:
	History	history[nhistory];	// most recent number/seed/phrase sets
	int	lasthistory;		// last used history entry, -1=none
	bool	modified;		// need to save in config file
};
