/*
 * this is the entry point for the MD4/MD5 computation. It is called from
 * the rest of the OTP tool. No other function is. Everything here was adapted
 * from skey-2.2, which originated at RSA. See skey_md[45].c for copyrights.
 *
 * All code in skey*.c is derived from RSA code. I changed the indentation,
 * removed code I didn't need, rewrote the calling code and converted to C++,
 * collected the code into fewer files, and allowed both MD4 and MD5 in the
 * same program, but the algorithms themselves are exactly the same as before.
 * thomas@bitrot.de, 7 Jan 2001.
 */

class Skey {
  public:
	void compute(
		bool	   md4,		// 1 for md4, 0 for md5
		int	   number,	// input number
		const char *seed,	// input seed
		const char *phrase);	// input passphrase

	char	out_word1[24];		// buffer for first three of six words
	char	out_word2[24];		// buffer for next three of six words
	char	out_hex[24];		// buffer for four-word hex result

  private:
	void f(char *out, char *in, int n);
	unsigned long extract(char *s, int start, int length);
	char *btoe(char *engout, char *c);
	char *put8(char *out, char *s);

	void MD4Final(unsigned char digest[16], MD_CTX *context);
	void MD5Final(unsigned char digest[16],	MD_CTX *context);

	bool use_md4;
};
